#include <stdio.h>
#include <stdlib.h>

#include "ptxlist.h"

#define CHECK if (!l) \
{ \
	printf ("FAILED\n"); \
	return EXIT_FAILURE; \
} \
else printf ("OK\n")

struct data_elem
{
	char *s;
	int nr;
};

void print_data (ptxlist *l)
{
	struct data_elem *tmp;
	
	printf ("print data: ");
	tmp = (struct data_elem *) get_list_element_data (l);
	if (!tmp)
	{
		printf ("FAILED\n");
		exit (EXIT_FAILURE);
	}
	
	printf ("data->nr = %d\n", tmp->nr);
}

int main (void)
{
	int i, ret;
	ptxlist *l = NULL;
	struct data_elem data;
	char *data_str = "0123456789abcdef";
	
	data.s = data_str;
	data.nr = 0;
	
	printf ("Check is_empty on nonexisting list: ");
	ret = is_empty(l);
	if (ret >= 0) {
		printf("FAILED\n");
		return EXIT_FAILURE;
	} else
		printf("OK\n");
	
	printf ("Init List: ");
	l = init_list ((void *) &data, sizeof (data));
	
	CHECK;

	printf ("Check if list is empty: ");
	ret = is_empty(l);
	if (ret <= 0) {
		printf("FAILED\n");
		return EXIT_FAILURE;
	} else
		printf("OK\n");
	
	printf ("Add 9999 Entrys: ");
	for (i = 1; i < 10000; i++)
	{
		data.nr = i;
		l = add_to_list (l, (void *) &data, sizeof (data));
		if (!l) break;
	}
	
	CHECK;
	
	printf ("goto head: ");
	goto_head (&l);
	CHECK;
		
	print_data (l);

	printf ("print next 5:\n");
	for (i = 0; i < 5; i++)
	{
		goto_next (&l);
		print_data (l);
	}
	
	printf ("goto tail: ");
	goto_tail (&l);
	CHECK;
	
	print_data (l);
	
	printf ("print prev 5:\n");
	for (i = 0; i < 5; i++)
	{
		goto_prev (&l);
		print_data (l);
	}
		
	printf ("Free List: ");
	
	del_list (l);
	
	printf ("OK\n");
	
	return EXIT_SUCCESS;
}
